#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

void chld_handler(int sig) {
	int status;
	waitpid(-1, &status, 0);
	printf("%d %d\n", WEXITSTATUS(status), getpid());
}

int main(int argc, char *argv[]) {
	int i;
	switch (fork()) {
		case 0:
			usleep(2500000);
			exit(3);
		default:
			signal(SIGCHLD, chld_handler);
			for (i = 0; i < 10; i++) {
				printf("tick %d\n", getpid());
				usleep(500000);
			}
			exit(0);
		case -1:
			perror("fork");
	}
}
