#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/wait.h>

sigset_t mask;
void chld_handler(int sig, siginfo_t *si, void *v) {
	int status;
	waitpid(-1, &status, 0);
	printf("%d %d sender = %d\n", WEXITSTATUS(status), getpid(), si->si_pid);
}

int main(int argc, char *argv[]) {
	int i;
	struct sigaction act = { .sa_sigaction = chld_handler, .sa_mask=mask};
	sigset_t suspmask;

	sigfillset(&mask);
	sigfillset(&suspmask);
	sigdelset(&suspmask, SIGCHLD);
	sigprocmask(SIG_SETMASK, &mask, NULL);

	switch (fork()) {
		case 0:
			sleep(3);
			exit(3);
		default:
			sigaction(SIGCHLD, &act, NULL);
			printf("%d\n", time(NULL));
			sleep(4);
			printf("%d\n", time(NULL));
			sigsuspend(&suspmask);
			printf("%d\n", time(NULL));
			exit(0);
		case -1:
			perror("fork");
	}
}
